## AgsFileIdRef

AgsFileIdRef — file id reference

## Stability Level

Stable, unless otherwise indicated

## Functions

#define | AGS_FILE_ID_REF_GET_OBJ_MUTEX()
#define | AGS_FILE_RESOLVE()
void | (*AgsFileResolve) ()
void | ags_file_id_ref_resolved ()
AgsFileIdRef * | ags_file_id_ref_new ()

## Properties

GObject * | file | Read / Write
gpointer | node | Read / Write
gpointer | reference | Read / Write
char * | xpath | Read / Write

## Signals

void | resolved | Run Last

## Types and Values

#define | AGS_FILE_ID_REF_SERIALIZE_DATA
#define | AGS_FILE_ID_REF_RESOLVE_DATA

## Object Hierarchy

        GObject
        ╰── AgsFileIdRef

## Includes

    #include <ags/file/ags_file_id_ref.h>

## Description

The AgsFileIdRef referes a XML node by its ID. It's used to perform XPath lookup.

## Functions

### AGS_FILE_ID_REF_GET_OBJ_MUTEX()

    #define AGS_FILE_ID_REF_GET_OBJ_MUTEX(obj) (&(((AgsFileIdRef *) obj)->obj_mutex))

### AGS_FILE_RESOLVE()

    #define AGS_FILE_RESOLVE(f)          ((AgsFileResolve)(f))

### AgsFileResolve ()

    void
    (*AgsFileResolve) (void);

### ags_file_id_ref_resolved ()

    void
    ags_file_id_ref_resolved (AgsFileIdRef *file_id_ref);

Notify about resolved reference.

#### Parameters

file_id_ref | the AgsFileIdRef |

Since: 3.0.0

### ags_file_id_ref_new ()

    AgsFileIdRef *
    ags_file_id_ref_new ();

Creates an AgsFileIdRef

#### Returns

a new AgsFileIdRef

Since: 3.0.0

## Types and Values

### AGS_FILE_ID_REF_SERIALIZE_DATA

    #define AGS_FILE_ID_REF_SERIALIZE_DATA "ags-file-id-ref-serizalize-data"

### AGS_FILE_ID_REF_RESOLVE_DATA

    #define AGS_FILE_ID_REF_RESOLVE_DATA "ags-file-id-ref-resolve-data"

## Property Details

### The `“file”` property

      “file”                     GObject *

The AgsFile this AgsFileIdRef belongs to.

Owner: AgsFileIdRef

Flags: Read / Write

Since: 3.0.0

### The `“node”` property

      “node”                     gpointer

The assigned xmlNode being referred by this AgsFileIdRef.

Owner: AgsFileIdRef

Flags: Read / Write

Since: 3.0.0

### The `“reference”` property

      “reference”                gpointer

The object referred by this AgsFileIdRef.

Owner: AgsFileIdRef

Flags: Read / Write

Since: 3.0.0

### The `“xpath”` property

      “xpath”                    char *

The XPath short-cut that can be used with this AgsFileIdRef.

Owner: AgsFileIdRef

Flags: Read / Write

Default value: NULL

Since: 3.0.0

## Signal Details

### The `“resolved”` signal

    void
    user_function (AgsFileIdRef *file_id_ref,
                   gpointer      user_data)

Signal ::resolved to notify about resolved :reference.

#### Parameters

file_id_ref | the AgsFileIdRef |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

Since: 3.0.0